Index: issm/trunk/src/c/classes/Inputs/TetraInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/TetraInput.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/TetraInput.cpp	(revision 18301)
@@ -13,28 +13,28 @@
 
 /*TetraInput constructors and destructor*/
-/*FUNCTION TetraInput::TetraInput(){{{*/
-TetraInput::TetraInput(){
+TetraInput::TetraInput(){/*{{{*/
 	values = NULL;
 }
 /*}}}*/
-/*FUNCTION TetraInput::TetraInput(int in_enum_type,IssmDouble* invalues,element_type_in){{{*/
-TetraInput::TetraInput(int in_enum_type,IssmDouble* in_values,int element_type_in)
-	:TetraRef(1)
-{
-
-	/*Set TetraRef*/
-	this->SetElementType(element_type_in,0);
-	this->element_type=element_type_in;
+TetraInput::TetraInput(int in_enum_type,IssmDouble* in_values,int interpolation_type_in){/*{{{*/
 
 	/*Set Enum*/
-	enum_type=in_enum_type;
+	this->enum_type=in_enum_type;
+	this->interpolation_type=interpolation_type_in;
+
+	int numnodes = this->NumberofNodes(this->interpolation_type);
 
 	/*Set values*/
-	this->values=xNew<IssmDouble>(this->NumberofNodes());
-	for(int i=0;i<this->NumberofNodes();i++) values[i]=in_values[i];
-}
-/*}}}*/
-/*FUNCTION TetraInput::~TetraInput(){{{*/
-TetraInput::~TetraInput(){
+	if (numnodes > 0){
+		this->values=xNew<IssmDouble>((unsigned int)numnodes);
+		for(int i=0;i<this->NumberofNodes(this->interpolation_type);i++) values[i]=in_values[i];
+	}
+	else{
+		this->values = NULL;
+	}
+
+}
+/*}}}*/
+TetraInput::~TetraInput(){/*{{{*/
 	xDelete<IssmDouble>(this->values);
 }
@@ -42,22 +42,18 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION TetraInput::Echo {{{*/
-void TetraInput::Echo(void){
+void TetraInput::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION TetraInput::DeepEcho{{{*/
-void TetraInput::DeepEcho(void){
+void TetraInput::DeepEcho(void){/*{{{*/
 
 	_printf_(setw(15)<<"   TetraInput "<<setw(25)<<left<<EnumToStringx(this->enum_type)<<" [");
-	for(int i=0;i<this->NumberofNodes();i++) _printf_(" "<<this->values[i]);
-	_printf_("] ("<<EnumToStringx(this->element_type)<<")\n");
-}
-/*}}}*/
-/*FUNCTION TetraInput::Id{{{*/
-int    TetraInput::Id(void){ return -1; }
-/*}}}*/
-/*FUNCTION TetraInput::ObjectEnum{{{*/
-int TetraInput::ObjectEnum(void){
+	for(int i=0;i<this->NumberofNodes(this->interpolation_type);i++) _printf_(" "<<this->values[i]);
+	_printf_("] ("<<EnumToStringx(this->interpolation_type)<<")\n");
+}
+/*}}}*/
+int    TetraInput::Id(void){ return -1; }/*{{{*/
+/*}}}*/
+int TetraInput::ObjectEnum(void){/*{{{*/
 
 	return TetraInputEnum;
@@ -65,8 +61,7 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::copy{{{*/
-Object* TetraInput::copy() {
-
-	return new TetraInput(this->enum_type,this->values,this->element_type);
+Object* TetraInput::copy() {/*{{{*/
+
+	return new TetraInput(this->enum_type,this->values,this->interpolation_type);
 
 }
@@ -74,6 +69,5 @@
 
 /*TetraInput management*/
-/*FUNCTION TetraInput::InstanceEnum{{{*/
-int TetraInput::InstanceEnum(void){
+int TetraInput::InstanceEnum(void){/*{{{*/
 
 	return this->enum_type;
@@ -81,22 +75,22 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::GetResultInterpolation{{{*/
-int  TetraInput::GetResultInterpolation(void){
-
+int  TetraInput::GetResultInterpolation(void){/*{{{*/
+
+	if(this->interpolation_type==P0Enum){
+		return P0Enum;
+	}
 	return P1Enum;
 
 }
 /*}}}*/
-/*FUNCTION TetraInput::GetResultNumberOfNodes{{{*/
-int  TetraInput::GetResultNumberOfNodes(void){
-
-	return this->NumberofNodes();
-
-}
-/*}}}*/
-/*FUNCTION TetraInput::ResultToPatch{{{*/
-void TetraInput::ResultToPatch(IssmDouble* values,int nodesperelement,int sid){
-
-	int numnodes = this->NumberofNodes();
+int  TetraInput::GetResultNumberOfNodes(void){/*{{{*/
+
+	return this->NumberofNodes(this->interpolation_type);
+
+}
+/*}}}*/
+void TetraInput::ResultToPatch(IssmDouble* values,int nodesperelement,int sid){/*{{{*/
+
+	int numnodes = this->NumberofNodes(this->interpolation_type);
 
 	/*Some checks*/
@@ -110,30 +104,26 @@
 
 /*Object functions*/
-/*FUNCTION TetraInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){{{*/
-void TetraInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){
+void TetraInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){/*{{{*/
 
 	/*Call TetraRef function*/
 	_assert_(gauss->Enum()==GaussTetraEnum);
-	TetraRef::GetInputValue(pvalue,&values[0],(GaussTetra*)gauss);
-
-}
-/*}}}*/
-/*FUNCTION TetraInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){{{*/
-void TetraInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){
+	TetraRef::GetInputValue(pvalue,&values[0],(GaussTetra*)gauss,this->interpolation_type);
+
+}
+/*}}}*/
+void TetraInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){/*{{{*/
 
 	/*Call TetraRef function*/
 	_assert_(gauss->Enum()==GaussTetraEnum);
-	TetraRef::GetInputDerivativeValue(p,&values[0],xyz_list,(GaussTetra*)gauss);
-}
-/*}}}*/
-/*FUNCTION TetraInput::ChangeEnum{{{*/
-void TetraInput::ChangeEnum(int newenumtype){
+	TetraRef::GetInputDerivativeValue(p,&values[0],xyz_list,(GaussTetra*)gauss,this->interpolation_type);
+}
+/*}}}*/
+void TetraInput::ChangeEnum(int newenumtype){/*{{{*/
 	this->enum_type=newenumtype;
 }
 /*}}}*/
-/*FUNCTION TetraInput::GetInputAverage{{{*/
-void TetraInput::GetInputAverage(IssmDouble* pvalue){
-
-	int        numnodes  = this->NumberofNodes();
+void TetraInput::GetInputAverage(IssmDouble* pvalue){/*{{{*/
+
+	int        numnodes  = this->NumberofNodes(this->interpolation_type);
 	IssmDouble numnodesd = reCast<int,IssmDouble>(numnodes);
 	IssmDouble value     = 0.;
@@ -145,6 +135,5 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::GetInputAllTimeAverages{{{*/
-void TetraInput::GetInputAllTimeAverages(IssmDouble** pvalues,IssmDouble** ptimes, int* pnumtimes){
+void TetraInput::GetInputAllTimeAverages(IssmDouble** pvalues,IssmDouble** ptimes, int* pnumtimes){/*{{{*/
 
 	IssmDouble* outvalues=NULL;
@@ -165,6 +154,5 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::GetInputUpToCurrentTimeAverages{{{*/
-void TetraInput::GetInputUpToCurrentTimeAverages(IssmDouble** pvalues, IssmDouble** ptimes, int* pnumtimes, IssmDouble currenttime){
+void TetraInput::GetInputUpToCurrentTimeAverages(IssmDouble** pvalues, IssmDouble** ptimes, int* pnumtimes, IssmDouble currenttime){/*{{{*/
 
 	IssmDouble* outvalues=NULL;
@@ -185,11 +173,10 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::SpawnTriaInput{{{*/
-Input* TetraInput::SpawnTriaInput(int index1,int index2,int index3){
+Input* TetraInput::SpawnTriaInput(int index1,int index2,int index3){/*{{{*/
 
 	/*output*/
 	TriaInput* outinput=NULL;
 
-	if(this->element_type==P0Enum){ 
+	if(this->interpolation_type==P0Enum){ 
 		outinput=new TriaInput(this->enum_type,&this->values[0],P0Enum);
 	}
@@ -218,8 +205,7 @@
 
 /*Intermediary*/
-/*FUNCTION TetraInput::SquareMin{{{*/
-void TetraInput::SquareMin(IssmDouble* psquaremin,Parameters* parameters){
-
-	int        numnodes=this->NumberofNodes();
+void TetraInput::SquareMin(IssmDouble* psquaremin,Parameters* parameters){/*{{{*/
+
+	int        numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble squaremin;
 
@@ -233,17 +219,15 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::ContrainMin{{{*/
-void TetraInput::ConstrainMin(IssmDouble minimum){
-
-	int numnodes = this->NumberofNodes();
+void TetraInput::ConstrainMin(IssmDouble minimum){/*{{{*/
+
+	int numnodes = this->NumberofNodes(this->interpolation_type);
 	for(int i=0;i<numnodes;i++) if (values[i]<minimum) values[i]=minimum;
 }
 /*}}}*/
-/*FUNCTION TetraInput::InfinityNorm{{{*/
-IssmDouble TetraInput::InfinityNorm(void){
+IssmDouble TetraInput::InfinityNorm(void){/*{{{*/
 
 	/*Output*/
 	IssmDouble norm=0.;
-	int numnodes=this->NumberofNodes();
+	int numnodes=this->NumberofNodes(this->interpolation_type);
 
 	for(int i=0;i<numnodes;i++) if(fabs(values[i])>norm) norm=fabs(values[i]);
@@ -251,8 +235,7 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::Max{{{*/
-IssmDouble TetraInput::Max(void){
-
-	int  numnodes=this->NumberofNodes();
+IssmDouble TetraInput::Max(void){/*{{{*/
+
+	int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble max=values[0];
 
@@ -263,8 +246,7 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::MaxAbs{{{*/
-IssmDouble TetraInput::MaxAbs(void){
-
-	int  numnodes=this->NumberofNodes();
+IssmDouble TetraInput::MaxAbs(void){/*{{{*/
+
+	int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble max=fabs(values[0]);
 
@@ -275,8 +257,7 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::Min{{{*/
-IssmDouble TetraInput::Min(void){
-
-	const int  numnodes=this->NumberofNodes();
+IssmDouble TetraInput::Min(void){/*{{{*/
+
+	const int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble min=values[0];
 
@@ -287,8 +268,7 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::MinAbs{{{*/
-IssmDouble TetraInput::MinAbs(void){
-
-	const int  numnodes=this->NumberofNodes();
+IssmDouble TetraInput::MinAbs(void){/*{{{*/
+
+	const int  numnodes=this->NumberofNodes(this->interpolation_type);
 	IssmDouble min=fabs(values[0]);
 
@@ -299,22 +279,19 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::Scale{{{*/
-void TetraInput::Scale(IssmDouble scale_factor){
-
-	const int numnodes=this->NumberofNodes();
+void TetraInput::Scale(IssmDouble scale_factor){/*{{{*/
+
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 	for(int i=0;i<numnodes;i++)values[i]=values[i]*scale_factor;
 }
 /*}}}*/
-/*FUNCTION TetraInput::Set{{{*/
-void TetraInput::Set(IssmDouble setvalue){
-
-	const int numnodes=this->NumberofNodes();
+void TetraInput::Set(IssmDouble setvalue){/*{{{*/
+
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 	for(int i=0;i<numnodes;i++)values[i]=setvalue;
 }
 /*}}}*/
-/*FUNCTION TetraInput::AXPY{{{*/
-void TetraInput::AXPY(Input* xinput,IssmDouble scalar){
-
-	const int numnodes=this->NumberofNodes();
+void TetraInput::AXPY(Input* xinput,IssmDouble scalar){/*{{{*/
+
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 	TetraInput*  xtriainput=NULL;
 
@@ -322,5 +299,5 @@
 	if(xinput->ObjectEnum()!=TetraInputEnum) _error_("Operation not permitted because xinput is of type " << EnumToStringx(xinput->ObjectEnum()));
 	xtriainput=(TetraInput*)xinput;
-	if(xtriainput->element_type!=this->element_type) _error_("Operation not permitted because xinput is of type " << EnumToStringx(xinput->ObjectEnum()));
+	if(xtriainput->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because xinput is of type " << EnumToStringx(xinput->ObjectEnum()));
 
 	/*Carry out the AXPY operation depending on type:*/
@@ -329,9 +306,8 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::Constrain{{{*/
-void TetraInput::Constrain(IssmDouble cm_min, IssmDouble cm_max){
+void TetraInput::Constrain(IssmDouble cm_min, IssmDouble cm_max){/*{{{*/
 
 	int i;
-	const int numnodes=this->NumberofNodes();
+	const int numnodes=this->NumberofNodes(this->interpolation_type);
 
 	if(!xIsNan<IssmDouble>(cm_min)) for(i=0;i<numnodes;i++)if (this->values[i]<cm_min)this->values[i]=cm_min;
@@ -340,11 +316,9 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::GetVectorFromInputs{{{*/
-void TetraInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){
+void TetraInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){/*{{{*/
 	const int numvertices=4;
 	vector->SetValues(numvertices,doflist,this->values,INS_VAL);
 } /*}}}*/
-/*FUNCTION TetraInput::PointwiseMin{{{*/
-Input* TetraInput::PointwiseMin(Input* inputB){
+Input* TetraInput::PointwiseMin(Input* inputB){/*{{{*/
 
 	/*Ouput*/
@@ -354,5 +328,5 @@
 	int         i;
 	TetraInput  *xinputB   = NULL;
-	const int   numnodes  = this->NumberofNodes();
+	const int   numnodes  = this->NumberofNodes(this->interpolation_type);
 	IssmDouble *minvalues = xNew<IssmDouble>(numnodes);
 
@@ -360,5 +334,5 @@
 	if(inputB->ObjectEnum()!=TetraInputEnum)       _error_("Operation not permitted because inputB is of type " << EnumToStringx(inputB->ObjectEnum()));
 	xinputB=(TetraInput*)inputB;
-	if(xinputB->element_type!=this->element_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->element_type));
+	if(xinputB->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->interpolation_type));
 
 	/*Create point wise min*/
@@ -369,5 +343,5 @@
 
 	/*Create new Tetra vertex input (copy of current input)*/
-	outinput=new TetraInput(this->enum_type,&minvalues[0],this->element_type);
+	outinput=new TetraInput(this->enum_type,&minvalues[0],this->interpolation_type);
 
 	/*Return output pointer*/
@@ -377,6 +351,5 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::PointwiseMax{{{*/
-Input* TetraInput::PointwiseMax(Input* inputB){
+Input* TetraInput::PointwiseMax(Input* inputB){/*{{{*/
 
 	/*Ouput*/
@@ -386,5 +359,5 @@
 	int         i;
 	TetraInput  *xinputB   = NULL;
-	const int   numnodes  = this->NumberofNodes();
+	const int   numnodes  = this->NumberofNodes(this->interpolation_type);
 	IssmDouble *maxvalues = xNew<IssmDouble>(numnodes);
 
@@ -392,5 +365,5 @@
 	if(inputB->ObjectEnum()!=TetraInputEnum) _error_("Operation not permitted because inputB is of type " << EnumToStringx(inputB->ObjectEnum()));
 	xinputB=(TetraInput*)inputB;
-	if(xinputB->element_type!=this->element_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->element_type));
+	if(xinputB->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->interpolation_type));
 
 	/*Create point wise max*/
@@ -401,5 +374,5 @@
 
 	/*Create new Tetra vertex input (copy of current input)*/
-	outinput=new TetraInput(this->enum_type,&maxvalues[0],this->element_type);
+	outinput=new TetraInput(this->enum_type,&maxvalues[0],this->interpolation_type);
 
 	/*Return output pointer*/
@@ -409,6 +382,5 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::PointwiseDivide{{{*/
-Input* TetraInput::PointwiseDivide(Input* inputB){
+Input* TetraInput::PointwiseDivide(Input* inputB){/*{{{*/
 
 	/*Ouput*/
@@ -417,10 +389,10 @@
 	/*Intermediaries*/
 	TetraInput *xinputB  = NULL;
-	const int   numnodes = this->NumberofNodes();
+	const int   numnodes = this->NumberofNodes(this->interpolation_type);
 
 	/*Check that inputB is of the same type*/
 	if(inputB->ObjectEnum()!=TetraInputEnum)     _error_("Operation not permitted because inputB is of type " << EnumToStringx(inputB->ObjectEnum()));
 	xinputB=(TetraInput*)inputB;
-	if(xinputB->element_type!=this->element_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->element_type));
+	if(xinputB->interpolation_type!=this->interpolation_type) _error_("Operation not permitted because inputB is of type " << EnumToStringx(xinputB->interpolation_type));
 
 	/*Allocate intermediary*/
@@ -434,5 +406,5 @@
 
 	/*Create new Tetra vertex input (copy of current input)*/
-	outinput=new TetraInput(this->enum_type,AdotBvalues,this->element_type);
+	outinput=new TetraInput(this->enum_type,AdotBvalues,this->interpolation_type);
 
 	/*Return output pointer*/
@@ -442,6 +414,5 @@
 }
 /*}}}*/
-/*FUNCTION TetraInput::Configure{{{*/
-void TetraInput::Configure(Parameters* parameters){
+void TetraInput::Configure(Parameters* parameters){/*{{{*/
 	/*do nothing: */
 }
Index: issm/trunk/src/c/classes/Inputs/TetraInput.h
===================================================================
--- issm/trunk/src/c/classes/Inputs/TetraInput.h	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/TetraInput.h	(revision 18301)
@@ -18,4 +18,5 @@
 	public:
 		int         enum_type;
+		int         interpolation_type;
 		IssmDouble* values;
 
Index: issm/trunk/src/c/classes/Inputs/TransientInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/TransientInput.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/TransientInput.cpp	(revision 18301)
@@ -14,6 +14,5 @@
 
 /*TransientInput constructors and destructor*/
-/*FUNCTION TransientInput::TransientInput(){{{*/
-TransientInput::TransientInput(){
+TransientInput::TransientInput(){/*{{{*/
 
 	enum_type=UNDEF;
@@ -25,6 +24,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::TransientInput(int in_enum_type){{{*/
-TransientInput::TransientInput(int in_enum_type)
+TransientInput::TransientInput(int in_enum_type)/*{{{*/
 {
 	/*Set Enum*/
@@ -39,6 +37,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::TransientInput(int in_enum_type,IssmDouble* timesin,int N){{{*/
-TransientInput::TransientInput(int in_enum_type,IssmDouble* timesin,int N){
+TransientInput::TransientInput(int in_enum_type,IssmDouble* timesin,int N){/*{{{*/
 
 	/*Set Enum*/
@@ -54,6 +51,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::~TransientInput{{{*/
-TransientInput::~TransientInput(){
+TransientInput::~TransientInput(){/*{{{*/
 	xDelete(this->timesteps);
 	this->timesteps=NULL;
@@ -66,11 +62,9 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION TransientInput::Echo {{{*/
-void TransientInput::Echo(void){
+void TransientInput::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION TransientInput::DeepEcho{{{*/
-void TransientInput::DeepEcho(void){
+void TransientInput::DeepEcho(void){/*{{{*/
 
 	int i;
@@ -86,9 +80,7 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::Id{{{*/
-int    TransientInput::Id(void){ return -1; }
-/*}}}*/
-/*FUNCTION TransientInput::ObjectEnum{{{*/
-int TransientInput::ObjectEnum(void){
+int  TransientInput::Id(void){ return -1; }/*{{{*/
+/*}}}*/
+int  TransientInput::ObjectEnum(void){/*{{{*/
 
 	return TransientInputEnum;
@@ -96,6 +88,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::copy{{{*/
-Object* TransientInput::copy() {
+Object* TransientInput::copy() {/*{{{*/
 
 	TransientInput* output=NULL;
@@ -105,9 +96,9 @@
 	output->numtimesteps=this->numtimesteps;
 	output->timesteps=xNew<IssmDouble>(this->numtimesteps);
-        xMemCpy(output->timesteps,this->timesteps,this->numtimesteps);
-	output->inputs=(Inputs*)this->inputs->Copy();
+	xMemCpy(output->timesteps,this->timesteps,this->numtimesteps);
+	output->inputs=static_cast<Inputs*>(this->inputs->Copy());
 	output->parameters=this->parameters;
 
-	return output;
+	return (Object*)output;
 
 }
@@ -115,6 +106,5 @@
 
 /*TransientInput management*/
-/*FUNCTION TransientInput::InstanceEnum{{{*/
-int TransientInput::InstanceEnum(void){
+int TransientInput::InstanceEnum(void){/*{{{*/
 
 	return this->enum_type;
@@ -122,6 +112,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::SpawnTriaInput{{{*/
-Input* TransientInput::SpawnTriaInput(int index1,int index2,int index3){
+Input* TransientInput::SpawnTriaInput(int index1,int index2,int index3){/*{{{*/
 
 	/*output*/
@@ -142,6 +131,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::SpawnSegInput{{{*/
-Input* TransientInput::SpawnSegInput(int index1,int index2){
+Input* TransientInput::SpawnSegInput(int index1,int index2){/*{{{*/
 
 	/*output*/
@@ -164,6 +152,5 @@
 
 /*Object functions*/
-/*FUNCTION TransientInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){{{*/
-void TransientInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){
+void TransientInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){/*{{{*/
 	IssmDouble time;
 
@@ -180,6 +167,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss,IssmDouble time){{{*/
-void TransientInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss,IssmDouble time){
+void TransientInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss,IssmDouble time){/*{{{*/
 
 	/*Retrieve interpolated values for this time step: */
@@ -192,6 +178,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){{{*/
-void TransientInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){
+void TransientInput::GetInputDerivativeValue(IssmDouble* p, IssmDouble* xyz_list, Gauss* gauss){/*{{{*/
 
 	IssmDouble time;
@@ -209,11 +194,9 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::ChangeEnum{{{*/
-void TransientInput::ChangeEnum(int newenumtype){
+void TransientInput::ChangeEnum(int newenumtype){/*{{{*/
 	this->enum_type=newenumtype;
 }
 /*}}}*/
-/*FUNCTION TransientInput::GetInputAverage{{{*/
-void TransientInput::GetInputAverage(IssmDouble* pvalue){
+void TransientInput::GetInputAverage(IssmDouble* pvalue){/*{{{*/
 
 	IssmDouble time;
@@ -232,6 +215,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::GetInputAllTimeAverages{{{*/
-void TransientInput::GetInputAllTimeAverages(IssmDouble** pvalues,IssmDouble** ptimes, int* pnumtimes){
+void TransientInput::GetInputAllTimeAverages(IssmDouble** pvalues,IssmDouble** ptimes, int* pnumtimes){/*{{{*/
 
 	int i;
@@ -254,6 +236,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::GetInputUpToCurrentTimeAverages{{{*/
-void TransientInput::GetInputUpToCurrentTimeAverages(IssmDouble** pvalues, IssmDouble** ptimes, int* pnumtimes, IssmDouble currenttime){
+void TransientInput::GetInputUpToCurrentTimeAverages(IssmDouble** pvalues, IssmDouble** ptimes, int* pnumtimes, IssmDouble currenttime){/*{{{*/
 
 	int         i;
@@ -299,6 +280,5 @@
 
 /*Intermediary*/
-/*FUNCTION TransientInput::AddTimeInput{{{*/
-void TransientInput::AddTimeInput(Input* input,IssmDouble time){
+void TransientInput::AddTimeInput(Input* input,IssmDouble time){/*{{{*/
 
 	/*insert values at time step: */
@@ -328,6 +308,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::AddTimeInput{{{*/
-void TransientInput::AddTimeInput(Input* input){
+void TransientInput::AddTimeInput(Input* input){/*{{{*/
 
 	_assert_(this->inputs->Size()<this->numtimesteps);
@@ -336,6 +315,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::GetResultInterpolation{{{*/
-int TransientInput::GetResultInterpolation(void){
+int  TransientInput::GetResultInterpolation(void){/*{{{*/
 
 	IssmDouble time;
@@ -352,6 +330,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::GetResultNumberOfNodes{{{*/
-int TransientInput::GetResultNumberOfNodes(void){
+int  TransientInput::GetResultNumberOfNodes(void){/*{{{*/
 
 	IssmDouble time;
@@ -368,6 +345,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::Extrude{{{*/
-void TransientInput::Extrude(void){
+void TransientInput::Extrude(void){/*{{{*/
 
 	for(int i=0;i<this->numtimesteps;i++){
@@ -376,6 +352,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::SquareMin{{{*/
-void TransientInput::SquareMin(IssmDouble* psquaremin,Parameters* parameters){
+void TransientInput::SquareMin(IssmDouble* psquaremin,Parameters* parameters){/*{{{*/
 
 	IssmDouble time;
@@ -394,6 +369,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::InfinityNorm{{{*/
-IssmDouble TransientInput::InfinityNorm(void){
+IssmDouble TransientInput::InfinityNorm(void){/*{{{*/
 
 	IssmDouble time;
@@ -414,6 +388,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::Max{{{*/
-IssmDouble TransientInput::Max(void){
+IssmDouble TransientInput::Max(void){/*{{{*/
 
 	IssmDouble time;
@@ -434,6 +407,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::MaxAbs{{{*/
-IssmDouble TransientInput::MaxAbs(void){
+IssmDouble TransientInput::MaxAbs(void){/*{{{*/
 
 	IssmDouble time;
@@ -455,6 +427,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::Min{{{*/
-IssmDouble TransientInput::Min(void){
+IssmDouble TransientInput::Min(void){/*{{{*/
 
 	IssmDouble time;
@@ -476,6 +447,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::MinAbs{{{*/
-IssmDouble TransientInput::MinAbs(void){
+IssmDouble TransientInput::MinAbs(void){/*{{{*/
 
 	IssmDouble time;
@@ -496,6 +466,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::GetVectorFromInputs{{{*/
-void TransientInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){
+void TransientInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){/*{{{*/
 
 	IssmDouble time;
@@ -513,6 +482,5 @@
 
 } /*}}}*/
-/*FUNCTION TransientInput::GetTimeInput{{{*/
-Input* TransientInput::GetTimeInput(IssmDouble intime){
+Input* TransientInput::GetTimeInput(IssmDouble intime){/*{{{*/
 
 	IssmDouble deltat;
@@ -520,4 +488,8 @@
 	int        found;
 	int        offset;
+	bool       interp;
+
+	/*First, recover interp bool: */
+	this->parameters->FindParam(&interp,TimesteppingInterpForcingsEnum);
 
 	Input *input  = NULL;
@@ -535,10 +507,10 @@
 		input=(Input*)((Input*)this->inputs->GetObjectByOffset(0))->copy();
 	}
-	else if(offset==(this->numtimesteps-1)){
+	else if(offset==(this->numtimesteps-1) || !interp){
 		/*get values for the last time: */
 		_assert_(intime>=this->timesteps[offset]);
 		input=(Input*)((Input*)this->inputs->GetObjectByOffset(offset))->copy();
 	}
-	else{
+	else {
 		/*get values between two times [offset:offset+1[, Interpolate linearly*/
 		_assert_(intime>=this->timesteps[offset] && intime<this->timesteps[offset+1]);
@@ -559,6 +531,5 @@
 }
 /*}}}*/
-/*FUNCTION TransientInput::Configure{{{*/
-void TransientInput::Configure(Parameters* parameters){
+void TransientInput::Configure(Parameters* parameters){/*{{{*/
 	this->parameters=parameters;
 }
